//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  hCardsDll = LoadLibrary("cards.dll");
  if (hCardsDll == NULL)
  {
    Application->MessageBox("Can't load cards.dll", "Error", MB_ICONERROR | MB_OK);
    Application->Terminate();
    return;
  }

  cdtInit    = (TcdtInitProc)    GetProcAddress(hCardsDll, "cdtInit");
  cdtAnimate = (TcdtAnimateProc) GetProcAddress(hCardsDll, "cdtAnimate");
  cdtDraw    = (TcdtDrawProc)    GetProcAddress(hCardsDll, "cdtDraw");
  cdtDrawExt = (TcdtDrawExtProc) GetProcAddress(hCardsDll, "cdtDrawExt");
  cdtTerm    = (TcdtTermProc)    GetProcAddress(hCardsDll, "cdtTerm");

  if (cdtInit == NULL || cdtAnimate == NULL || cdtDraw == NULL
   || cdtDrawExt == NULL || cdtTerm == NULL)
  {
    cdtTerm = NULL;
    Application->MessageBox("Can't get procedure address", "Error", MB_ICONERROR | MB_OK);
    Application->Terminate();
    return;
  }

  if (!cdtInit(&CardWidth, &CardHeight))
  {
    cdtTerm = NULL;
    Application->MessageBox("Can't init cards.dll", "Error", MB_ICONERROR | MB_OK);
    Application->Terminate();
    return;
  }

  hDesktopDC = GetWindowDC(GetDesktopWindow());

  Image1->Picture->Bitmap->Width = CardWidth;
  Image1->Picture->Bitmap->Height = CardHeight;
  ClientWidth = Image1->Left + CardWidth + 5;
  ClientHeight = CardHeight + Image1->Top * 2;
  ComboMark->ItemIndex = 0;
  ComboNumber->ItemIndex = 0;
  ComboNumberChange(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  if (hDesktopDC)
    ReleaseDC(GetDesktopWindow(), hDesktopDC);
  if (hCardsDll)
  {
    if (cdtTerm)
      cdtTerm();
    FreeLibrary(hCardsDll);
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboNumberChange(TObject *Sender)
{
  if (ComboMark->ItemIndex == -1 || ComboNumber->ItemIndex == -1)
    return;
  cdtDraw(Image1->Canvas->Handle, 0, 0, ComboMark->ItemIndex + ComboNumber->ItemIndex * 4, 0, 0xFFFFFF);
  Image1->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonScatterClick(TObject *Sender)
{
  if (Timer1->Enabled)
  {
    Timer1->Enabled = !Timer1->Enabled;
    ValidateRect(NULL, NULL);
  }
  else
  {
    Timer1->Enabled = !Timer1->Enabled;
    if (!hDesktopDC)
      return;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  if (!hDesktopDC)
    return;
  cdtDraw(hDesktopDC, random(Screen->Width + CardWidth) - CardWidth, random(Screen->Height + CardHeight) - CardHeight, random(4) + random(13) * 4, 0, 0xFFFFFF);
}
//---------------------------------------------------------------------------
